#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"kawkfunc.h"
char    *
formnull()          /* return the format file name */
{
    if(isnull(ffn)) print("\007<no format file>\n");
    return(ffn);
}
char    *
formfile(is)        /* set the format file name */
char    *is;
{
    if(isnull(is))  {
        listfile();
        return(NULL);
        }
    ffn = free_if(ffn);
    ffn = xpandsh(is,NULL);
    return(ffn);
}
char    *
cmdfile(argc,argv)  /* get files from command line */
int	 	argc;
char	*argv[];
{
/**/
    zerofile();
/**/
	rfn = free_if(rfn);
/**/
	rfn = cmdlist(argc,argv,ZERO,NULL);
/**/
	nfile = filecnt(rfn);
/**/
	return(rfn);
}
void
listfile()      /* report on the input files */
{
	if(isnull(ffn))	printf("NO FORMAT FILE\n");
	else		printf("FORMAT FILE\n");
	filespec(ffn);
	if(isnull(rfn))	printf("NO READ FILES\n");
	else		printf("READ FILES\n");
	filespec(rfn);
	return;
}
filespec(is)
char	*is;
{
	auto	char	fn[FNMSIZ];
	auto	int		fc = 0;
	auto	long	fs;
	auto	char	*fm;
	while((int) (is = xgnc(fn,fn+FNMSIZ,is,' ')))	{
		if((fs = filesize(fn)) >= 1L)	{
			fm = filemod(fn);
			}
		else	{
			fs = 0L;
			fm = "<new file>";
			}
		printf("%3d %6ld %10s %s\n",fc,fs,fm,fn);
		fc += 1;
		}
	return;
}
char	*
termfile(is)        /* get files from terminal */
char    *is;
{
/**/
	if(isnull(is))	{
		listfile();
		return(NULL);
		}
/**/
    zerofile();
/**/
	rfn = free_if(rfn);
/**/
	rfn = xpandsh(is,NULL);
/**/
	nfile = filecnt(rfn);
/**/
    return(rfn);
}
