#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"keyproto.h"
/*EXTERN*/
extern int printf();
/*STATIC*/
static		int	ask = 0;
static		int	clr = 0;
/**/
prlist(n1,n2,is)        /* list or print card */
int   n1;
int	n2;
char    *is;
{
	auto	int		i;
	auto	FUNCP	func = (FUNCP) NULL;
	auto	FUNCP	nunc = (FUNCP) NULL;
/***determine the print request, if any***/
	nunc = nupr ? printf : nunc;
	for( ; *is != ZERO; is++)
		switch(*is)	{
		case	'Z':
		case	'z':
		case	'T':
		case	't':		func = (FUNCP) xtwrcd;
							break;
		case	'#':		nunc = (FUNCP) printf;
		case	'P':
		case	'p':		func = (FUNCP) xwrcdf;
							break;
		case	'l':
		case	'L':		func = (FUNCP) xlwrcdf;
							break;
		default:			break;
		}
/***no print requested***/
	if(func == NULL)		return(0);
/***determine clearing, query***/
	ask = ((cdx.glb || n2 > n1) && (kenv.leisur & DB)) ? 1 : 0;
	clr = (kenv.leisur & DA) ? 1 : 0;
/***loop through list***/
	for(i = n1;i <= n2; i++) {
		getcd(i,LINE_IO);
		if(clr)				scr_cl(stdout);
		if(nunc)			(*nunc)("(%d)\n",i);
		(*func)(kb.base,stdout,kenv.folder,NULL);
	if(ask && query(stdout) == 'q')	{
		cdx.con = NO;
		terror(FUBAR);
		break;
		}
	}
	cdx.cur = n2;
	return(cdx.con = YES);
}
char	*
xtwrcd(is,fp,fw)
char	*is;
FILE	*fp;
int	fw;
{
	auto	char	*err;
	clcd();
	xtocd(is,'v');
	twrcd(fp,'f',fw);
	if((int)(err = rderr(NULL)))	{
		errmsg("xtwrcd <use p to see bad or duplicated key> '%s'\n",err);
		}
	return(0);
}
