#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#define		ALLOCATE
#include	"ksyskwik.h"
/**/
#include	<setjmp.h>
#include	<signal.h>
#ifdef		MSDOS
#else		/*MSDOS*/
#include	<sgtty.h>
#endif		/*MSDOS*/
#define		MAXERR		16
/*EXTERN*/
/*LOCAL*/
/*GLOBAL*/
char		mfn[FNMSIZ];		/* syn def file */
#ifndef	SYSV
#undef	SETVBUF
#endif	/*SYSV*/
/**/
jmp_buf     here;
/**/
void
terror(ty)
int		ty;
{
	static	NOSIGN	loop = ZERO;
/**/
	if(loop++ >= MAXERR)	exit(FUBAR);
/**/
	if(ty == SIGINT)	signal(SIGINT,SIG_IGN);
/**/
	clearerr(stdin);
/**/
	efclean(ofp);      	/* close open files */
	ifp = xfp = (FILE *) NULL;
	ifb = free_if(ifb);
	xfb = free_if(xfb);
/**/
#ifdef	MSDOS
#else
	if(isatty(0))	{	/* RESET TERMINAL STATE */
		termset(0,CBREAK,NO);
		termset(0,ECHO,YES);
		}
#endif
/**/
	if(ty == 0)	kenv.prompt = 0;
/**/
	kenv.prompt = (first && kenv.prompt && isatty(0) && isatty(1)) ? 1 : 0;
/**/
	if(kenv.prompt)     {
		longjmp(here,1);
		}
	exit(ty);
}
/**/
main(argc,argv)
int		argc;
char	*argv[];
{
	if(cmderr(argc,argv,"BCDEFGHMNQRSVWbcehltuxz0123456789"))
		terror(FUBAR);
	kenv.dosdos = isdos();
	disnme(kenv.pname = WHO_AM_I);
	exit(cmdxrc(argc,argv,(FUNCP) kwik,"kwik.xrc"));
	return(0);	/* LINT */
}
long
kwik(argc,argv)
int		argc;
char	*argv[];
{
	signal(SIGINT,exit);
/**/
	if(kenv.dosdos)	{
		cmdxpd(argc,argv);
		amode = "ab";
		wmode = "wb";
		rmode = "rb";
		}
	else	{
		amode = "a";
		wmode = "w";
		rmode = "r";
		}
	telluser(kenv.pname);
/**/
	kenv.prompt = isatty(0);
/**/
	kenv.leisur = kenv.prompt && (baudrate(stdout) >= 1200) ? (DA | DB) : 0;
/**/
	if(cmdnum(argc,argv,'W',0,1))	{
		whoru(stdout);
		exit(0);
		}
	if(cmdnum(argc,argv,'h',0,1))	{
		if(kenv.leisur)	{
			whoru(stdout);
			query(stdout);
			}
		exit(hint(0));
		}
/**/
	setmod((long) cmdnum(argc,argv,'H',MODFAC,MODFAC));
	kenv.flags6 = cmdnum(argc,argv,'M',1,0);
	kenv.flags2 = cmdnum(argc,argv,'G',GRANULE,GRANULE);
/**/
	kenv.blockd = cmdnum(argc,argv,'B',16,16) * bufsiz();
	sob = emalloc( bufsiz(), "main:sob");
	setbuf(ofp = stdout,sob);
/**/
	kenv.diagno = cmdnum(argc,argv,'D',0,DA);
	kenv.report = cmdnum(argc,argv,'R',0,DA);
#ifdef	__TURBOC__
/*
|	without this code, the first call to stat() always gives the wrong
|	time, off by the time zone differential (?)
*/
	{
	auto	long	now;
	time(&now);
	ctime(&now);
	}
#endif	/*__TURBOC__*/
/**/
	kenv.folder = cmdnum(argc,argv,'F',64,64);
/**/
	setrbuf(cmdnum(argc,argv,'b',4096,4096));
/**/
	kenv.flags1 = cmdnum(argc,argv,'S',DA|DB|DC,DA|DB|DC);
/**/
	if(isatty(0) && isatty(1))	{
		kenv.prompt = DA | DB;
		}
/**/
	kenv.flags4 = cmdnum(argc,argv,'e',0,1);
	expr = cmdstr(argc,argv,'e',kgetenv("KWIKEXPR"));
	xndx = cmdstr(argc,argv,'x',kgetenv("KWIKINDEX"));
	undx = cmdstr(argc,argv,'u',kgetenv("KWIKINDEX"));
/**/
	if(cmdnum(argc,argv,'c',0,DA))	rdfunc = xrdcd;
	else
	if(cmdnum(argc,argv,'t',0,DA))	rdfunc = rdpara;
	else
	if(cmdnum(argc,argv,'l',0,DA))	rdfunc = fgetlf;
	else							rdfunc = xrdcd;
/**/
	if(cmdnum(argc,argv,'N',0,DA))	{
		auto	char	*barf;
		barf = cmdstr(argc,argv,'N',NULL);
		strcpy(note,barf);
		barf = free_if(barf);
		if(!(kenv.flags1 & DD))	{
			errmsg("<note specified with bad -S option>\n");
			exit(FUBAR);
			}
		}
/**/
	if(kenv.prompt)	{
		if(cmdnum(argc,argv,'C',DA,DA))	kenv.leisur |= DA;
		if(cmdnum(argc,argv,'Q',DA,DA))	kenv.leisur |= DB;
		if(cmdnum(argc,argv,'V',0,DA))	kenv.leisur |= DC;
		if(cmdnum(argc,argv,'E',0,DA))	kenv.leisur |= DD;
		}
/**/
	if(undx == NULL)	{
		rfn = cmdlist(argc,argv,ZERO,kgetenv("KWIKFILES"));
		}
/**/
	setcbrk(YES);
/**/
	if(signal(SIGINT,SIG_IGN) == SIG_IGN)	{
		signal( SIGINT, (FUNCS) terror );
		}
/**/
	if(kenv.flags6)	getmacros();
/**/
	if(expr)	cmdexpr(expr);
	else		doterm();
/**/
	return(0);
}
getmacros()
{
	auto	char	*mf;
	auto	char	mb[BLKSIZ];
	auto	int		rt = 0;
	extern	char	*findfile();
	mf = findfile("kwik.mac",3,".",kgetenv("HOME"),kgetenv("$PUBKIN"));
	if(mf)	{
		strcpy(mb,mf);
		strcpy(mfn,mf);
		mf = free_if(mf);
		rt = doso(mb,mb+BLKSIZ-1);
		}
	return(rt);
}
doterm()
{
	setjmp(here);
	signal(SIGINT,(FUNCS) terror);
	if(first++ == ZERO)	{
		if(kenv.prompt)	{
			whoru(stdout);
			query(stdout);
			}
		}
	return(rdcmd(ls,ls+BLKSIZ-1,stdin));
}
char	*
outset(is)
char	*is;
{
	auto	char	*isx = is;
	auto	char	*fmode = NULL;
	auto	char	*fname = NULL;
	auto	char	ws[FNMSIZ];
	auto	int		check = YES;
/*
**	set the output file
*/
/***close any files that may be open***/
	efclean(NULL);
/**/
	if(kenv.dosdos)	system("exit");	/* force a reset */
/**/
/***set output to stdout***/
	ofp = stdout;
	ofn = free_if(ofn);
/***if stdout is really wanted, return***/
	if(strcmp(isx,"w") == 0)		return(ofn);
/***set mode***/
	if(strncmp(isx,"w>>",3) == 0)			{
		fname = strcnd(isx + 3);
		fmode = amode;
		if(filesize(strcnd(fname)) <= 0L)		{
				prwho(" <zero or does not exist> '%s'\n",fname);
				}
		check = NO;
		}
	else
	if(strncmp(isx,"w!",2) == 0)	{
		fmode = wmode;
		fname = strcnd(isx+2);
		if(unlink(strcnd(fname)))		{
			prwho(" <new file> '%s'\n",fname);
			}
		check = NO;
		}
	else
	if(strncmp(isx,"w !",3) == 0)	{
		fname = strcnd(isx+3);
		fmode = wmode;
		if(!(ofp = epopen(isx,fmode)))	return(outset(NULL));
		else							return(NULL);
		}
	else
	if(strncmp(isx,"w ",2) == 0)		{
		fname = strcnd(isx+2);
		fmode = wmode;
		}
	else	{
		errmsg("outset <bad syntax> '%s'\n",is);
		terror(FUBAR);
		}
/***expand file names***/
	strcpy(ws,fname);
	xpandsh(ws,ws+FNMSIZ-1);
/***check for overwrite***/
	if(check && filesize(fname) >= 1L)	{
		errmsg("outset <to overwrite use> 'w! %s'\n",fname);
		terror(FUBAR);
		}
/***open the file***/
	ofn = free_if(ofn);
	ofn = strsave(ws);
	if(!(ofp = efopen(ofn,fmode)))	{
/***force a shift to stdout***/
		outset("w");
		terror(FUBAR);
		}
/***buffer the sucker***/
#ifdef	SETVBUF
	ofb = ksetvbuf(ofp,ofb,_IOFBF,kenv.blockd);
#endif	/*SETVBUF*/
	return(ofn);
}
rdcmd(ls,lu,fp)
char	*ls;
char	*lu;
FILE	*fp;
{
	auto	char	*lsx;
	auto	char	*lsz;
	auto	int	pr = isatty(fileno(fp));
/*
**	read and "parse" commands
*/
	for( ; ; )	{
/**/
		if(pr)	{
			scr_so(stdout);
			fputs("(",stdout);
			if(kenv.timing)				fputs("T",stdout);
			if(kenv.flags7)				fputs("z",stdout);
			if(kenv.flags0 == CMODE)	fputs("c",stdout);
			else
			if(kenv.flags0 == KMODE)	fputs("k",stdout);
			else
			if(kenv.flags0 == HMODE)	fputs("h",stdout);
			fputs(") ",stdout);
			printff("(%s)=>",kenv.pname);
			scr_se(stdout);
			}
/**/
	if(!(lsx = fgetlf(lsz = ls, lu, fp)))	break;
/**/
	if(strncmp(ls,"syn",3) == ZERO)		{
		lsx = strcnd(ls+3);
#ifdef	DEBUG
	fprintf(stderr,"synsyn(%s)\n",lsx);
#endif	/*DEBUG*/
		synsyn(lsx);
#ifdef	DEBUG
	fprintf(stderr,"synsyn(%s)\n",lsx);
#endif	/*DEBUG*/
		continue;
		}
/**/
	lsx += 1;	/* work area */
/**/
	while((int)(lsz = xgnc(lsx,lu,lsz,'@')))	{
/**/
#ifdef	DEBUG
	fprintf(stderr,"get_syn(%s)\n",lsx);
#endif	/*DEBUG*/
		get_syn(lsx);
#ifdef	DEBUG
	fprintf(stderr,"get_syn(%s)\n",lsx);
#endif	/*DEBUG*/
/**/
		if(pcmd(lsx,lu))	{
			fp = xfclose(fp);
			}
		}
/**/
	}
/**/
	if(pr)	{
		errmsg("rdcmd <use q to quit>\n");
		clearerr(fp);
		terror(FUBAR);
		}
/**/
	return(0);
}
pcmd(ls,lu)
char	*ls;
char	*lu;
{
	auto	char	*lsx = NULL;
/**/
	while(isspace(*ls))	++ls;
/**/
	if(hascntrl(ls))		terror(FUBAR);
/**/
	lsx = ls + 1 ;
	while(isspace(*lsx))	++lsx;
/**/
	if(rdcmd1(ls,lu))		return(0);
/**/
	switch(ls[0])	{
	case	':':	/* comment */
	when	'B':	kenv.blockd = atoi(lsx) * bufsiz();
	when	'b':	setrbuf(atoi(lsx));
	when	'c':	rdfunc = xrdcd;
	when	'C':	if(kenv.leisur & DA)	kenv.leisur &= ~DA;
					else					kenv.leisur |= DA;
	when	'D':	kenv.diagno = atoi(lsx);
	when	'e':	invalid('e');
	when	'E':	if(kenv.leisur & DD)	kenv.leisur &= ~DD;
					else					kenv.leisur |= DD;
	when	'F':	kenv.folder = atoi(lsx);
					kenv.folder = kenv.folder >= 79 ? 64 : kenv.folder;
					kenv.folder = kenv.folder <= 0  ? 64 : kenv.folder;
	when	'f':	filespecs();
	when	'g':	gomode(ls);
	when	'G':	kenv.flags2 = atoi(ls+1);
					kenv.flags2 = kenv.flags2 ? kenv.flags2 : GRANULE;
	when	'H':	setmod(atol(ls+1));
	when	'h':	hint(0);
	when	'#':	printf("%u %s\n",strhash(ls+1),ls+1);
	when	'l':	rdfunc = fgetlf;
	when	'L':	scr_cl(stdout);
	when	'M':	more(lsx,rfn);
	when	'm':	more(lsx,ofn);
	when	'N':	strcpy(note,lsx);
					if(strlen(note) && !(kenv.flags1 & DD))	{
						errmsg("<note specified with bad -S option>\n");
						}
	when	'o':	outset(ls);
	when	'p':	showpat();
	when	'Q':	if(kenv.leisur & DB)	kenv.leisur &= ~DB;
					else					kenv.leisur |= DB;
#ifdef	DEBUG
	fprintf(stderr,"leisur: %o %d\n",kenv.leisur,kenv.leisur);
#endif	/*DEBUG*/
	when	'q':	doquit(0);
	when	'R':	kenv.report = atoi(lsx);
	when	'r':	rfnset(lsx);
	when	'S':	kenv.flags1 = atoi(lsx);
	when	's':	makeindex(ls[0],lsx);
	when	'T':	kenv.timing = !kenv.timing;
	when	't':	rdfunc = rdpara;
	when	'u':	makeindex(ls[0],lsx);
	when	'V':	if(kenv.leisur & DC)	kenv.leisur &= ~DC;
					else					kenv.leisur |= DC;
	when	'W':	whoru(stdout);
	when	'w':	outset(ls);
	case	'x':	makeindex(ls[0],lsx);
	when	'Z':	makeindex(ls[0],lsx);
	when	'z':	showlist(stdout);
	when	'X':	whatfile("main");
	when	'!':	doshell(lsx,rfn,ofn);
	when	'?':	hint(0);
	when	'&':	makepat(lsx,'&');
	when	'|':	makepat(lsx,'|');
	when	'/':	svepat(lsx);
					break;
	default:		fputs("\007????? '",stderr);
					fputs(ls,stderr);
					fputs("'\n",stderr);
					terror(FUBAR);
					break;
	}
	return(0);
}
rdcmd1(os,us)	/* moscellaneous functions */
char	*os;
char	*us;
{
	if(strncmp(os,"so",2) == 0)	{
		strcpy(os,os+2);
		xpandsh(os,os+BLKSIZ-16);
		doso(strcnd(os),us);
		return(1);
		}
	if(strncmp(os,"cd",2) == 0)	{
		if(kchdir(strcnd(os+2)) < 0)	return(-1);
		else							return(1);
		}
	else
	if(strncmp(os,"sh",2) == 0)	return(system("sh"),1);
	return(0);
}
doso(os,us)	/* take command from a file */
char	*os;
char	*us;
{
	auto	FILE	*ifp = NULL;
	ifp = efopen(os,rmode);
	sfn = free_if(sfn);
	sfn = strsave(os);
	rdcmd(os,us,ifp);
	ifp = xfclose(ifp);
	return(0);
}
gomode(is)	/* decide sweep type */
char	*is;
{
	auto	FILE	*stdrep = isatty(1) ? stdout : stderr;
	static	char	lm[3];
/**/
	counts.totl = 0L;
	counts.cout = 0L;
	counts.curf = 0L;
	ttyo = isatty(fileno(ofp));
/**/
	if(isnull(lm))	strcpy(lm,"gk");
	switch(is[1])	{
	case	NULL:	gomode(lm);
	when	'h':	strcpy(lm,"gh");
					kenv.flags0 = HMODE;
					dohash();
	when	'c':	strcpy(lm,"gc");
					kenv.flags0 = CMODE;
					doloop((FUNCP) kwiker);
	when	'k':	strcpy(lm,"gk");
					kenv.flags0 = KMODE;
					doloop((FUNCP) krep);
					break;
	default:		errmsg("gomode <bad mode> '%s'\n",is);
					terror(FUBAR);
	}
	if(ofp != stdout && (kenv.report & DA))	{
		fprintf(stdrep,"%ld records selected from %ld total\n",
			counts.cout,counts.totl);
		}
	return(0);
}
void
showpat()
{
	if(kenv.prompt) printf("%s\n",curpat);
	return;
}
char	*
rfnset(is)
char	*is;
{
	if(isnull(is))	{
		if(isnull(ofn))	{
			errmsg("rfnset <no previous output file>\n");
			terror(FUBAR);
			}
		rfnset(ofn);
		outset("w");
		if(kenv.prompt & DB)	{
			printf("\007<reading previous output> '%s'\n",rfn);
			}
		return(rfn);
		}
/**/
	rfn = free_if(rfn);
	rfn = xpandsh(is,NULL);
/**/
	kenv.tracer = ZERO;
/**/
	return(rfn);
}
showfile(ty,is)
NOSIGN	ty;
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	long	fs;
	auto	char	*fm;
	auto	int		nf = ZERO;
	auto	int		br = ZERO;
	while((int)(is = xgnc(ws,ws+FNMSIZ-1,is,' ')))	{
		nf += 1;
		br = ((kenv.leisur & DA) && !(nf % 20)) ? 1 : 0;
		if(br)	{
			if(query(stdout) == 'q')	return(0);
			if(kenv.leisur & DA)		scr_cl(stdout);
			}
		fm = (fm = filemod(ws)) ? fm : "???   new   ???" ;
		fs = filesize(ws);
		printf("%c %15.15s %6ld %s\n",ty,fm,fs,ws);
		}
	return(0);
}
void
filespecs()
{
/**/
	if(kenv.dosdos)	system("exit");	/* force flush, reset */
/**/
	if(!kenv.prompt)		return;
	if(kenv.leisur & DA)	scr_cl(stdout);
/**/
	if(isnull(ofn))	printff("NO OUTPUT FILE\n");
	else			showfile('O',ofn);
/**/
	if(isnull(mfn))		printff("NO MACRO FILE\n");
	else				showfile('M',mfn);
/**/
	if(!kenv.ndexed)	printff("NO INDEX FILE\n");
	else				showfile('X',xfn);
/**/
	printff("MODULO FACTOR: %ld\n",modfac);
/**/
	printff("GRANULARITY: %u\n",kenv.flags2);
/**/
	flagprt(stdout,kenv.flags1,"card","number","file","note",NULL);
/**/
	flagprt(stdout,kenv.leisur,"clear","query","veri","echo",NULL);
/**/
	if(rdfunc == xrdcd)		printff("READING CARDS\n");
	else
	if(rdfunc == rdpara)	printff("READING TEXT\n");
	else
	if(rdfunc == fgetlf)	printff("READING LINES\n");
	printff("BLOCK SIZE: %u\n",kenv.blockd);
	printff("FOLD POINT: %u\n",kenv.folder);
	{
	char	*breaks = rtpara();
	if(breaks)
	printff("TEXT BREAKS: %s\n",rtpara());
	}
/**/
	if(isnull(rfn))	printff("NO INPUT FILE LIST\n");
	else			{
		if((kenv.leisur & DB) && query(stderr) == 'q')	return;
		showfile('I',rfn);
		}
/**/
	return;
}
void
cmdexpr(expr)
char	*expr;
{
	auto	char	*ps = NULL;
	auto	char	*go = NULL;
/**/
	if(kenv.flags4 == 1)	go = "gc";
	else
	if(kenv.flags4 == 2)	go = "gk";
	else
	if(kenv.flags4 == 3)	go = "gh";
	else	{
		errmsg("<illegal value with -eN option>\n");
		terror(FUBAR);
		}
/**/
	kenv.prompt = 0;
/*	
*	the expression may be expanded
*/
	ps = emalloc(bufsiz(),"main:expr");
	strcpy(ps,expr);
/**/
	if(xndx)	{
		makeindex('x',xndx);
		strxty(ps,'+',' ');
		svepat(ps);
		go = "gh";
		}
	else
	if(undx)	{
		makeindex('u',undx);
		strxty(ps,'+',' ');
		svepat(ps);
		go = "gh";
		}
	else
	if(strchr("|&/",ps[0]))  	makepat(ps+1,ps[0]);
	else						svepat(ps);
/**/
	gomode(go);
/**/
	return;
}
more(os,is)
char	*os;
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	char	*fsx = os;
/**/
	diskreset();
/**/
	if(kenv.dosdos)	system("exit");	/* force a flush, reset */
/**/
	if(isnull(os))	fsx = is;
	while((int)(fsx = xgnc(ws,ws+FNMSIZ-1,fsx,' ')))	{
/**/
		ifp = xfclose(ifp);
		xpandsh(ws,ws+FNMSIZ-1);
		ifp = tefopen(ws,rmode);
/**/
#ifdef	SETVBUF
		ifb = ksetvbuf(ifp,ifb,_IOFBF,kenv.blockd);
#endif	/*SETVBUF*/
/**/
		while((*rdfunc)(kb.base,kb.bmax,ifp))	{
/**/
			if(kenv.leisur & DA)	scr_cl(stdout);
/**/
			xwrcdf(kb.base,stdout,kenv.folder,NULL);
/**/
			if(kenv.leisur & DB)	{
				if(query(stdout) == 'q')	break;
				}
			}
/**/
		if(!isnull(fsx))	{
			if(query(stdout) == 'q')	break;
			}
/**/
		}
	ifp = xfclose(ifp);
	ifb = free_if(ifb);
	return(ZERO);
}
doquit(ty)
int		ty;
{
	if(kenv.ndexed)	{
		prwho(" <index file retained> '%s'\n",xfn);
		}
	terror(0);
	return(0);	/* LINT */
}
invalid(cx)
int		cx;
{
	errmsg("<no meaning in interactive mode> '%c'\n",cx);
	terror(FUBAR);
	return(FUBAR);	/* LINT */
}
