/*COMLIB*/
#define		NULL_OUT
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#define		DOSARG		128
#define		UNXARG		5120
#define		DASH		'-'
#define		HUGE		9999
#define		SLEEP		3
/**/
/*EXTERNAL*/
extern	KENV	kenv;
/**/
#ifdef	DEBUG
cmdprt(argc,argv,is)
char	*is;
int		argc;
char	*argv[];
{
	auto	int		i;
	auto	int		l = ZERO;
	if(is)	fprintf(stderr,"=====<%s>=====\n",is);
	for(i = 0; i < argc; i++)	{
		l += strlen(argv[i]);
		fprintf(stderr,"%2d %3d %s\n",i,l,argv[i]);
		}
	sleep(SLEEP);
	return(argc);
}
#else	DEBUG
cmdprt()
{
	return( 0 );
}
#endif	DEBUG
cmdbig(argc,argv)
int		argc;
char	*argv[];
{
	auto	int		ta = ZERO;
	auto	int		ma = kenv.dosdos ? DOSARG : UNXARG;
	auto	int		i;
/**/
	ma -= ma / 10;
/**/
	for(i = 0; i < argc; i++)	ta += strlen(argv[i]);
/**/
	if(ta >= ma)	{
		errmsg("cmdbig <argument truncation>\n");
		sleep(SLEEP);
		}
/**/
	return(ma);
}
char	*
cmdlist(argc,argv,tc,ds)
int		argc;
char	*argv[];
int		tc;			/* token character */
char	*ds;		/* default string */
{
	return(cmdfind(argc,argv,tc,ds,HUGE));
}
char	*
cmdstr(argc,argv,tc,ds)
int		argc;
char	*argv[];
int		tc;			/* token character */
char	*ds;		/* default string */
{
	return(cmdfind(argc,argv,tc,ds,1));
}
char	*
cmdfind(argc,argv,tc,ds,nc)
int		argc;
char	*argv[];
int		tc;				/* tag character */
char	*ds;			/* default string */
int		nc;				/* number of items to return */
{
/*
	ntc must equal argc to prevent string processing when no
	tag is on the command line.
*/
	auto	int		i;
	auto	int		ntc = argc;	/* first string after tag */
	auto	char	*rs = NULL;	/* return pointer */
	auto	char	fs[3];		/* flag string */
#ifdef	DEBUG
	fprintf(stderr,"cmdfind(%u,%u,%c,%s,%u)\n",
		argc,argv,tc,ds,nc);
	cmdprt(argc,argv,"cmdfind");
#endif	DEBUG
/*
*	use strsave to allocate space for a character string
*	developed from the command line as
*	-t one two three
*	or
*	one two three
*/
/**/
	if(tc == ZERO)	{
		for(i = 1; i < argc; i++)
			if(argv[i] == NULL)				;
			else
			if(strcmp(argv[i],"-") == 0)	break;
			else
			if(*argv[i] == DASH)			;
			else	{
				rs = stradd(rs,argv[i]);
#ifdef	NULL_OUT
		argv[i] = NULL;
#endif	NULL_OUT
				}
		return(what(rs,ds));
		}
/**/
	fs[0] = DASH;
	fs[1] = (char) tc;
	fs[2] = ZERO;
/**/
	for(i = 1; i < argc; i++)
	if(argv[i] && strncmp(argv[i],fs,2) == ZERO)	ntc = i + 1;
/**/
	for(i = ntc; i < argc && nc >= 1; i++)
	if(argv[i] == NULL)		break;
	else
	if(*argv[i] == DASH)	break;
	else	{
		nc -= 1;
		rs = stradd(rs,argv[i]);
#ifdef	NULL_OUT
		argv[i] = NULL;
#endif	NULL_OUT
		}
	return(what(rs,ds));
}
char	*
what(os,is)
char	*os;		/* result string */
char	*is;		/* default string */
{
	if(os)	return(strcnd(os));
	else
	if(is)	return(strsave(strcnd(is)));
	else	return(NULL);
}
#ifdef	TEST
main(argc,argv)
int		argc;
char	**argv;
{
	auto	char	ls[BUFSIZ];
	auto	char	*xp[16];
	auto	int		nxp = 0;
	auto	char	*user;
	while(putchar('?'),gets(ls))
	switch(ls[0])	{
	case	'q':	fclose(stdin);
					break;
	case	'u':	printf("user (%s)\n",user);
					break;
	case	'F':	nxp = getqs(xp,16,strcnd(ls+1));
					puts(cmdstr(nxp,xp,'s',"s flag"));
					puts(cmdlist(nxp,xp,'t',"t flag"));
					puts(cmdlist(nxp,xp,'x',"x flag"));
					break;
	case	'N':	nxp = getqs(xp,16,strcnd(ls+1));
					puts(cmdstr(nxp,xp,'s',"s flag"));
					puts(cmdlist(nxp,xp,'t',"t flag"));
					puts(cmdlist(nxp,xp,'x',"x flag"));
					puts(cmdlist(nxp,xp,NULL,"no flag"));
					break;
	default:		puts("N no flag");
					puts("F flags (-s, -t, -x)");
					puts("q quit");
	}
}
#endif
