#define		NEW_TIME
#include	"pdtar.h"
#include	"pdproto.h"
#include	<time.h>
/**/
#ifdef	NEW_TIME
newtime(fp,mtime)
FILE	*fp;
time_t	mtime;
{
	auto	struct	tm	*ftime;
	ftime = localtime(&mtime);
	fprintf(fp,"%02d:%02d:%02d ",
		ftime->tm_year,ftime->tm_mon,ftime->tm_mday);
	fprintf(fp,"%02d:%02d ",
		ftime->tm_hour,ftime->tm_min);
	return;
}
#endif	/*NEW_TIME*/
char	*
showuppr(is,ty)	/* show path in upper case */
int		ty;
char	*is;
{
#ifdef	MSDOS
	auto	char	*eop;
	if(ty == 1)	{
		if((int)(eop = strrchr(is,'/')))	{
			*eop = 0;
			strupr(is);
			*eop = '/';
			}
		}
	else
	if(ty == 2)	strlwr(is);
	return(is);
#else
	return(is);
#endif
}
prhead(f_name,phstat)
STAT	*phstat;
char	*f_name;
{
	auto	RECORD	*head;
	auto	char	ws[32];
	auto	char	*lx;
	auto	int		dif;
	head = &curhead;
	if(device.extotal)	{
		fprintf(stdrpt,"[extent %d of %d]\n",
			device.extno,device.extotal);
		}
	if(oswitch.verbose)	{
		fprintf(stdrpt,"%03o", (int) phstat->st_mode & 0777);
		fputs(" ",stdrpt);
		fprintf(stdrpt,"%4d",  (int) phstat->st_uid);
		fputs("/",stdrpt);
		fprintf(stdrpt,"%-4d", (int) phstat->st_gid);
		fprintf(stdrpt,"%8ld", (long) phstat->st_size);
		fputs(" ",stdrpt);
#ifdef	NEW_TIME
		newtime(stdrpt,phstat->st_mtime);
#else	/*NEW_TIME*/
		strcpy(ws,ctime(&phstat->st_mtime));
		strcpy(ws,ws+4);
		strcpy(ws+12,ws+15);
		ws[17] = 0;
		fputs(ws,stdrpt);
		fputs(" ",stdrpt);
#endif	/*NEW_TIME*/
		}
	showname(NULL,lx = head->header.name,NULL);
	if(lf_typ == LF_NOR)	{
		dif = dstrcmp(lx,f_name);
		if(dif)	showname(" (",f_name,")");
		}
	else
	if(lf_typ == LF_LIN)	{
		showname(" -> ",l_name,NULL);
		}
	fputs("\n",stdrpt);
	fflush(stdrpt);
	return(0);
}
showname(beg,name,end)
char	*beg;
char	*name;
char	*end;
{
	if(beg)	fputs(beg,stdrpt);
	showuppr(name,1);
	fputs(name,stdrpt);
	showuppr(name,2);
	if(end)	fputs(end,stdrpt);
	return(0);
}
RECORD	*
decode(head)
RECORD	*head;
{
	auto	STAT	*phstat = &hstat;
	phstat->st_mode = (unsigned) from_oct(8, head->header.mode);
	phstat->st_uid = (unsigned) from_oct(8, head->header.uid);
	phstat->st_gid = (unsigned) from_oct(8, head->header.gid);
	phstat->st_mtime = from_oct(12, head->header.mtime);	/* 13? */
#ifdef	MSDOS
	if(oswitch.convert)
		phstat->st_mtime = ktimeutd(phstat->st_mtime);
#endif
	phstat->st_size = from_oct(12, head->header.size);
	device.extno = (unsigned) from_oct(4, head->header.extno);
	device.extotal = (unsigned) from_oct(4, head->header.extotal);
	device.efsize = from_oct(12, head->header.efsize);	/* 13 ? */
/**/
	fixname(f_rname,f_name,head->header.name);
	fixname(l_rname,l_name,head->header.linkname);
/**/
	lf_typ = head->header.linkflag;
	if(lf_typ == LF_OLD)	lf_typ = LF_NOR;
	else					lf_typ = LF_LIN;
/**/
	return(head);
}
#ifdef	MSDOS
dstrncmp(os,is,nc)	/* compare nchars, ignoring case */
char	*os;
char	*is;
int		nc;
{
	return(strnicmp(os,is,nc));
}
dstrcmp(os,is)		/* compare, ignoring case */
char	*os;
char	*is;
{
	return(stricmp(os,is));
}
#else
dstrcmp(os,is)
char		*os;
char		*is;
{
	return(strcmp(os,is));
}
dstrncmp(os,is,nc)
char		*os;
char		*is;
int			nc;
{
	return(strncmp(os,is,nc));
}
#endif
