/*DOSLIB*/
/*UNXLIB*/
#include        "ksysdefs.h"
#include        "ksysvtyp.h"
#include        "ksysprot.h"
/*EXTERNAL*/
#ifdef  CAN_PROTO
extern int baud(int,char **);
extern int dotime(FILE *);
extern int dobaud(FILE *);
extern int hint(int);
#else
extern int baud();
extern int dotime();
extern int dobaud();
extern int hint();
#endif
/*GLOBAL*/
int     br;
int     bs;
int     rt;
KENV            kenv;
void
terror(ty)
int ty;
{
    exit(ty);
}
main(argc,argv)
int     argc;
char    *argv[];
{
    kenv.dosdos = isdos();
    disnme(kenv.pname = "baud");
    exit(cmdxrc(argc,argv,baud,"baud.xrc"));
	return(0);
}
baud(argc,argv)
int     argc;
char    *argv[];
{
/**/
    setbuf(stdout,emalloc(bufsiz(),"main"));
/**/
    if(kenv.dosdos) cmdxpd(argc,argv);
    else            telluser(kenv.pname);
/**/
    disrec(cmdnum(argc,argv,'R',1,0));
/**/
        if(cmdnum(argc,argv,'W',0,1))   {
                whoru(stdout);
                exit(0);
                }
        if(cmdnum(argc,argv,'h',0,1))   exit(hint(0));
/**/
        if(kenv.dosdos) br = 9600;
        else            br = baudrate(stdout);
/**/
        if(cmdnum(argc,argv,'r',0,1))   {
                printf("%d\n",br);
                exit(0);
        }
        if(cmdnum(argc,argv,'s',0,DA))  {
        if(kenv.dosdos) {
            errmsg("<not available under MSDOS> '-s'\n");
            exit(FUBAR);
            }
            bs = cmdnum(argc,argv,'b',300,br);
            rt = br / bs;
            rt -= 1;
            dolist(argc,argv,dobaud);
            }
        else
        if(kenv.flags0 = cmdnum(argc,argv,'x',0,DA))    {
            bs = cmdnum(argc,argv,'b',300,br);
            dolist(argc,argv,dotime);
            }
        exit(0);
		return(0);
}
dotime(fp)
FILE    *fp;
{
    extern  long    filesize();
    auto    long    fs;
    auto    double  fx;
    auto    long    ft;
    auto    long    hour;
    auto    long    mint;
    auto    long    secs;
    fs = filesize(getcfn());
    fx = (double) fs / ((double) bs / (double) 10);
    ft = (long) fx;
    if(kenv.flags0 & DA)    {
        hour = ft / 3600;
        ft %= 3600;
        mint = ft / 60;
        ft %= 60;
        secs = ft;
        printf("%02ld:%02ld:%02ld ",hour,mint,secs);
        }
    if(kenv.flags0 & DB)    printf("%s ",getcfn());
    if(kenv.flags0)     printf("\n");
    return(ZERO);
}
dobaud(fp)
FILE    *fp;
{
        REG int cx;
        REG int pdx;
        REG int rtx = rt;
                while((cx = getc(fp)) != EOF)
                {
                        putchar(cx);
                        for(pdx = rtx; pdx >= 1; pdx--)
                                putchar((int) NULL);
                }
        return(ZERO);
}
static  char    *hx[] = {
"=baud [-snnnn] [files]",
"        print/simmulate a lower baud rate",
"=OPTIONS",
"-r      print baud rate",
"-s      simulate a given baud rate (not under MSDOS)",
"-b??    baud rate [9600 default under MSDOS]",
"-x      time in minutes to transmit file at given rate",
"-x3     add name to transmission time",
"=",
"~",
"=EXAMPLES",
"       baud -r",
"       reports the baud rate for the current tty line",
"       baud -s -b300 < garbage",
"       lists (cats) the file garbage at 300 baud",
"       baud -x -b4800 garbage",
"       list the time to transmit garbage at 4800 baud",
"=CAVEATS",
"       no allowance is made for protocol overhead in the",
"       calculation of transmit rates.",
"=",
}   ;
hint(ty)
{
    prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
    exit(ty);
	return(0);
}
