#define	TURBOC
/*
	test bed for checking the behavior of various
	xenix and dos file functions
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
KENV		kenv;
terror(ty)
{
	exit(ty);
}
main()
{
	extern	char	*filemod();
	extern	long	filesize();
	extern	long	filemraw();
	extern	long	filelength();
	extern	FILE	*efopen();
	auto	char	ls[BUFSIZ];
	auto	char	cf[BUFSIZ];
	auto	FILE	*fp = stdout;
	extern	long	ftell();
	strcpy(cf,"testfile.tmp");
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'q':	fclose(stdin);
					break;
	case	'!':	system(ls+1);
					break;
	default:
	case	'?':	
					puts("r open file");
					puts("a open file");
					puts("w open file");
					puts("c close file");
					puts("g get drive");
					puts("G set drive");
					puts("e error message");
					puts("f name set file");
					puts("F flush");
					puts("l file length");
					puts("L attribute (0,1,2,4,16,32)");
					puts("m raw mod time");
					puts("M formated mod time");
					puts("n new file name");
					puts("p position (ftell)");
					puts("R rewind");
					puts("s size in characters");
					puts(">text to file");
					break;
	case	'L':	findlist(cf,atoi(ls+1));
	case	'l':	printf("%s %ld\n",cf,filelength(fileno(fp)));
					break;
	case	'F':	fflush(fp);
					break;
	case	'n':	rename(cf,strcnd(ls+1));
					strcpy(cf,strcnd(ls+1));
					break;
	case	'R':	rewind(fp);
					break;
	case	'p':	printf("%ld\n",ftell(fp));
					break;
	case	'>':	fprintf(fp,"%s\n",ls+1);
					break;
	case	'c':	if(fp != stdout)	fclose(fp);
						break;
	case	'e':	perror("");
						break;
	case	'a':	if(fp != stdout)	fclose(fp);
						fp = efopen(cf,"a");
						break;
	case	'w':	if(fp != stdout)	fclose(fp);
						fp = efopen(cf,"w");
						break;
	case	'r':	if(fp != stdout)	fclose(fp);
						fp = efopen(cf,"r");
						break;
	case	'f':	strcpy(cf,strcnd(ls+1));
					break;
	case	'M':	printf("%s %s\n",cf,filemod(cf));
					break;
	case	'm':	printf("%s %ld\n",cf,filemraw(cf));
					break;
	case	's':	printf("%s %ld\n",cf,filesize(cf));
					break;
	}
	exit(0);
}
#ifdef		TURBOC
#include	<dir.h>
#include	<dos.h>
findlist(is,ty)
char	*is;
int	ty;
{
	auto	struct	ffblk	ffblk;
	auto	int	done;
	auto	int	wide = 0;
	auto	int	flen;
	done = findfirst(is,&ffblk,ty);
	while(!done)	{
		flen = strlen(ffblk.ff_name);
		wide += flen + 1;
		if(wide >= 78)	{
			fputs("\n",stdout);
			wide = flen + 1;
			}
		fputs(ffblk.ff_name,stdout);
		fputs(" ",stdout);
		done = findnext(&ffblk);
	}
	return(0);
}
#endif
