#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<signal.h>
/*EXTERN*/
extern char *fputu(char *,FILE *);
extern long elpased(void);
extern void timeout(int);
extern int doonefile(FILE *);
extern int rdonefile(FILE *);
extern void nextfile(void);
extern void logit(char *);
FILE	*lfp;
char	*lfb;
char	ofn[FNMSIZ];
char	ls[BUFSIZ];
long	start;
KENV	kenv;
void
timeout(ty)
int		ty;
{
	logit("timeout");
	errmsg("<timeout>\n");
	terror(ty);
	return;
}
void
terror(ty)
int		ty;
{
	if(filesize(ofn) <= 0L)	{
		unlink(ofn);
		logit("removed empty file");
		logit(ofn);
		}
	system("stty ek;stty");
	logit("killed");
	errmsg("<killed> %d\n",ty);
	exit(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	time(&start);
	lfp = tefopen("monitor.log","w");
#ifdef	SYSV
	lfb = ksetvbuf(lfp,lfb,_IOLBF,bufsiz());
#endif	/*SYSV*/
	kenv.flags0 |= cmdnum(argc,argv,'u',DA,DB);
	kenv.talarm = cmdnum(argc,argv,'t',30,30);
	kenv.report = cmdnum(argc,argv,'r',50,50);
	signal(SIGALRM,timeout);
	system("stty erase '^X' kill '^U';stty");
	dolist(argc,argv,doonefile);
}
long
elapsed()
{
	auto	long	now;
	time(&now);
	return(now - start);
}
doonefile(fp)
FILE	*fp;
{
	auto	int		lines;
	while(1)	{
		kenv.screen += 1;
		strcpy(ofn,"nbXXXXXX.tmp");
		maketemp(ofn);
		logit("transfer file named");
		logit(ofn);
		if(!freopen(ofn,"w",stdout))	{
			prterr("'%s'");
			terror(FUBAR);
			}
		nextfile();
		lines = rdonefile(fp);
		fprintf(stderr,"%d lines\n",lines);
	}
}
void
nextfile()
{
	fprintf(stderr,"\007<begin next transmission>\n");
	return;
}
rdonefile(fp)
FILE	*fp;
{
	kenv.slines = 0;
	alarm(kenv.talarm);
	logit("waiting on first line");
	while(fgets(ls,BUFSIZ-1,fp))	{
		if(kenv.flags0 & DA) fputu(ls,stdout);
		else				fputs(ls,stdout);
		alarm(kenv.talarm);
		kenv.slines += 1;
		if(kenv.slines % kenv.report == 0)	{
			logit("received lines");
			}
		}
	logit("end of file");
	return(kenv.slines);
}
char	*
fputu(is,fp)
char	*is;
FILE	*fp;
{
	REG		char	*isx = is;
	static	NOSIGN	under = 0;
#define		BS		'\b'
#define		US		'_'
	while(*isx != 0)	{
		if(isx[1] == BS && isx[2] == US)	{
			if(under++ == 0)	fputs("\\fB",fp);
			putc(isx[0],fp);
			isx += 3;
			}
		else
		if(under)	{ fputs("\\fR",fp); under = 0; }
		putc(*isx++,fp);
		}
	return(is);
}
void
logit(is)
char	*is;
{
	fprintf(lfp,"%4ld ",elapsed());		/* elapsed time */
	fprintf(lfp,"%3d ",kenv.screen);	/* file number */
	fprintf(lfp,"%5d ",kenv.slines);	/* file lines */
	fprintf(lfp,"%s ",is);				/* message */
	fprintf(lfp,"\n");					/* end of line */
	return;
}
