#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"ksyskref.h"
/**/
#ifdef		isbull
#undef		isbull
#endif
/*EXTERN*/
/*GLOBAL*/
fileloop(is,fu)		/* loop through a list of files */
char	*is;		/* list of files */
int		(*fu)();	/* function to call */
{
	static	char	*here = "fileloop";
	auto	char	*ifb = NULL;
	auto	char	ws[FNMSIZ];
	auto	char	*isx = is;
	auto	FILE	*fp = NULL;
	auto	int		nf = 0;
	auto	char	*fn = NULL;
/*
|	loop through text file list
*/
	while((int) (isx = xgnc(ws,ws+FNMSIZ-1,isx,' ')))	{
		if(ws[0] == '-' && ws[1] == 0)	fp = stdin;
		else							fp = tefopen(ws,"r");
#ifdef	SYSV
		ifb = ksetvbuf(fp,ifb,_IOFBF,bufsiz());
#endif	/*SYSV*/
		fn = strsave( ws );	/* do not free */
		(*fu)(fp,fn);
		xfclose(fp);
		nf += 1;
	}
	ifb = free_if(ifb);
	return(nf);
}
dotfile(fp,fn)		/* read one text, extract ".bs" */
FILE	*fp;		/* file pointer */
char	*fn;		/* file name */
{
	static	char		*here = "dotfile";
	auto	NOSIGN		ln = 0;
	auto	char		*ft;
	ft = rindex(fn,'/');
	ft = ft ? (ft + 1) : fn;
/**/
	while(fgetls(bufo,bufu,fp))	{
/**/
		if(kenv.report & DA)	{
			if(!(ln % 100))
				fprintf(stderr,"%6u %14.14s\r",ln,ft);
			}
/**/
		ln += 1;
/**/
		if(isbull(bufo))	{
/*			ADD .bs TO TABLE */
			addbs(bufo+3,ln,fn);
			continue;
			}
/**/
		if(source(bufo))	{
			auto	char	sob[FNMSIZ];
/*			PURSUE .so FILES */
			strcnd(bufo+3);
			strcpy(sob,bufo+3);
			fileloop(sob,dotfile);
			continue;
			}
	}
/**/
	return(ln);
}
