#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
#define		FILEMAC
#undef		FILEMAC
#define		OLDIO
#define     LNE         '\n'
#define     LCB         '{'
#define     RCB         '}'
#define     DEVINDX     "./indexXXXXXX"
#define     DEVNULL     "/dev/null"
#define     DEVTERM     "/dev/tty"
#define     TRMWAIT     120         /* wait on terminal reads */
#if	HUGE == 9999
#undef	HUGE
#define	HUGE 	(((unsigned) ~0) >> 1)
#endif
#ifdef		MSDOS
#include	"ksysgtty.h"
#else
#include	<sgtty.h>
#endif
#include    <signal.h>
/*EXTERN*/
extern	char	*free_if();
/**/
xnx(nv,is)              /* pretend file has ended */
char    *is;
{
	xfclose(x[nv].ifp);
	return(0);
}
#ifdef		CAN_INDEX
xix(nv,is)          /* index function */
char    *is;
{
	static	char	*xb = NULL;
	auto	char	*wr = kenv.dosdos ? "w+b" : "w+" ;
	if(!xfp)    {
		xfp = tefopen(DEVINDX,wr);
		xb = emalloc(bufsiz(),"xix");
		setbuf(xfp,xb);
		}
	indwrt(xfp,is,x[nv].cp,x[nv].vp);
	return(0);
}
indwrt(fp,is,cp,vp)     /* write index line */
FILE    *fp;
char    *is;
{
	REG     char    *isx = is;
	REG     FILE    *fpx = fp;
	while(*isx != ZERO)
	if(*isx == WORD)    isx += 2;
	else
	if(*isx >= ' ' && *isx <= '~')  putc(*isx++,fpx);
	else
	if(*isx == BSP)                 putc(*isx++,fpx);
	else                            ++isx;
	fprintf(fp,"%d %d\n",cp,vp);
	return(0);
}
#else		CAN_INDEX
xix(nv,is)
char	*is;
int		nv;
{
	errmsg("xix <index function not implemented>\n");
	terror(FUBAR);
}
#endif		CAN_INDEX
xcd(nv,is)          /* change current directory */
char    *is;
{
	if(isnull(is))  is = getenv("HOME");
	if(chdir(is) < 0)   {
		prterr("<%s>",is);
		terror(FUBAR);
	}
	else    return(0);
}
xrw(nv,is)          /* rewind the current input file */
char    *is;
{
	rewind(x[nv].ifp);
	return(ZERO);
}
xfl(nv,is)          /* flush output file */
char    *is;
{
	return(fflush(x[nv].ofp));
}
xso(nv,is)          /* pursue '.so' files */
char    *is;
{
	auto    nlx = 0;
	auto    FILE    *sfp = x[nv].ifp;
	auto	char	*ib;
	auto	char	*rd = kenv.dosdos ? "rb" : "r" ;
/*
**  modify to allow different so's for each environment
*/
	if(nv >= 1) badenv(nv,"xso",FUBAR);
	x[nv].so += 1;
	strcnd(is);
	filepush(is);
	x[nv].ifp = tefopen(is,rd);
/**/
	ib = emalloc(bufsiz(),"xso");
	setbuf(x[nv].ifp,ib);
/**/
	nlx = rdfile(nv,ifp = x[nv].ifp,HUGE,1);
	xfclose(x[nv].ifp);
	ib = free_if(ib);
/**/
	filepop();
	ifp = x[nv].ifp = sfp;
	x[nv].so -= 1;
	return(nlx);
}
xli(nv,is)          /* literal input */
char    *is;
{
	auto    int     ta = x[nv].ta;
	auto    int     tc = x[nv].tc;
	auto    int     lc = x[nv].lc;
	auto    char    ts[3];
	auto	char	*ws = emalloc(BLKSIZ,"xli");
	REG     int     nlx = 0;
/*  set tabs to KINMONTH settings */
	zta(4);
	ztc('\t');
	zlc(' ');
	x[nv].li = 1;
	strcnd(is);
	if(isnull(is))  strcpy(ts,"..");
	else            strncpy(ts,is,2);
	ts[2] = ZERO;
	while(fgetlf(ls,ls+BLKSIZ-1,ifp))
	if(ls[0] == ts[0] && ls[1] == ts[1])    break;
	else        tblwrt(nv,xtab(ws,ws+BLKSIZ-1,ls));
/*  restore tabs to initial settings */
	zta(ta);
	ztc(tc);
	zlc(lc);
	x[nv].li = 0;
	if(feof(x[nv].ifp)) badeof(nv,".li",FUBAR);
	ws = free_if(ws);
	return(nlx);
}
xig(nv,is)          /* skip ignored text */
char    *is;
{
	auto    char    ts[3];
	auto	char	*ls = emalloc(BLKSIZ,"xig");
	REG     int     nlx = 0;
	x[nv].ig = 1;
	strcnd(is);
	if(isnull(is))  strcpy(ts,"..");
	else            strncpy(ts,is,2);
	ts[2] = ZERO;
	while(fgetlf(ls,ls+BLKSIZ-1,x[nv].ifp))
	if(ls[0] == ts[0] && ls[1] == ts[1])    break;
	x[nv].ig = 0;
	if(feof(x[nv].ifp)) badeof(nv,".ig",FUBAR);
	ls = free_if(ls);
	return(nlx);
}
xtm(nv,is)          /* write to terminal */
char    *is;
{
	x[nv].tm = 1;
	fflush(x[nv].ofp);
	fputs(is,stderr);
	putc('\n',stderr);
	x[nv].tm = 0;
	return;
}
xrd(nv,is)          /* read input from terminal */
char    *is;
{
	REG     int     nlx = 0;
	auto    int     to;
	x[nv].rd = 1;
	to = alarm(TRMWAIT);
	strcnd(is);
	if(isnull(is))  putc('\007',stderr);
	else            {fputs(is,stderr);putc('\n',stderr);}
	if(isatty(0))   {
					nlx = rdfile(nv,stdin,HUGE,1);
					clearerr(stdin);
					}
	else            {
		auto    FILE    *tfp;
#ifdef	SUN
			tfp =fdopen(dup(2),"r");
#else
			tfp = tefopen(DEVTERM,"r");
#endif
		nlx = rdfile(nv,tfp,HUGE,1);
		fclose(tfp);
	}
	alarm(to);
	x[nv].rd = 0;
	return(nlx);
}
/*
**  file name walk back for diagnostic purposes
*/
#define NWALK   8                   /* depth of walk back stack */
/*
*/
static  char    fw[BLKSIZ];         /* file names */
static  char    *fwx = fw;
static  char    *fwu = fw + BLKSIZ -1;
static  char    *fs[NWALK];         /* file stack */
static  int     df = 0;             /* stack index */
/*
*/
char    *
filepush(is)        /* save file sequence */
char    *is;
{
	if(df >= NWALK)     return(NULL);
#ifdef	FILEMAC
	{
	auto	char	ws[32];
	sprintf(ws,"EF %s",is);
	xds(0,ws);
	}
#endif
	fwx = strkat(fs[df++] = fwx,fwu,is) + 1;
	return(is);
}
char    *
filepop()           /* fetch file */
{
	auto	char		*os;
	if(df <  0)         return(NULL);
	os = fs[--df];
#ifdef	FILEMAC
	{
	auto	char	ws[32];
	sprintf(ws,"EF");
	xrm(0,ws);
	if( (df-1) >= 0)	{
		sprintf(ws,"EF %s",fs[df-1]);
		xds(ws);
		}
	}
#endif
	return(os);
}
filewalk()          /* print walkback sequence */
{
	REG     char    *isx;
	while((int) (isx = filepop()))    {
		fprintf(stderr,"%s\n",isx);
	}
	return(ZERO);
}
#ifndef		__MEDIUM__
xpi()
{
	notinsml("xpi");
}
#else
xpi(nv,is)          /* pipe output to command */
char    *is;
{
#ifdef	MSDOS
	notindos("pipe");
#else
	x[nv].pi = 1;
	strcnd(is);
	if(isnull(is))  {
		if(pofp)    xfclose(pofp);
		pofp = (FILE *) NULL;
		return(ZERO);
		}
	if(!(pofp = epopen(is,"w"))) {
		errmsg("xpi <bad pipe> '%s'\n",is);
		terror(SIGPIPE);
		}
	x[nv].pi = 0;
	x[nv].ofp = pofp;
#endif
	return(0);
}
#endif		__MEDIUM__
#ifndef		__MEDIUM__
xip()
{
	notinsml("xip");
}
#else
xip(nv,is)          /* read input from pipe */
char    *is;
{
#ifdef	MSDOS
	notindos("pipe");
#else
	auto	char	*ib;
	REG     int     nlx = 0;
	x[nv].ip = 1;
	if(pifp)    xfclose(pifp);
	if(!(pifp = epopen(strcnd(is),"r")))   {
		errmsg("xip <bad pipe> '%s'\n",is);
		terror(SIGPIPE);
		}
/**/
	ib = emalloc(bufsiz(),"xip");
	setbuf(pifp,ib);
/**/
	nlx = rdfile(nv,pifp,HUGE,1);
	xfclose(pifp);
	ib = free_if(ib);
/**/
	x[nv].ip = 0;
#endif
	return(ZERO);
}
#endif		__MEDIUM__
char	*
prtesc(os,fp,is)
char	*os;	/* string to print */
char	*is;	/* location or header */
FILE	*fp;	/* output file */
{
	if(!isnull(is))	fputs(is,fp);
	funxesc(os,fp);
	return(os);
}
