#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/*
	9.19.87	files combined
	9.19.87	CR handling changed
*/
/**/
#define		ISOSIZ		512
/**/
#ifndef     ONFONT
#define     ONFONT      1
#define     NOFONT      0
#endif
/**/
static		int			il = 0;
/**/
/*EXTERNAL*/
/**/
char	*
eater(nv,is,ty)		/* consume input */
int	nv;
char    *is;
int	ty;			/* ty = 1 -> discard; ty = 0 -> use */
{
/*
**	consume input through NULL \{ \}
**	sequence
*/
	REG		char	*isx = is;
	REG		int		icb = 0;
	auto	char	*tbx = NULL;
	auto	char	*tbe = NULL;
/**/
	while(isspace(*isx))    ++isx;
	while(*isx != ZERO)
	if(*isx == ESC && isx[1] == LCB)	{
		icb += 1;
		isx += 2;
		while(isspace(*isx))	++isx;
		if(icb == 1)			tbx = isx;
		}
	else
	if(*isx == ESC && isx[1] == RCB)	{
		if(icb == 1)			tbe = isx;
		icb -= 1;
		isx += 2;
		while(isspace(*isx))	++isx;
		}
	else						++isx;
	if(icb)	{
		errmsg("eater <bracket error>\n%s\n",is);
		terror(FUBAR);
		}
	*isx = ZERO;
	if(tbx)			{
		*tbe = ZERO;
		while(*tbx != ZERO && (*tbx <= ' ' || *tbx > '~'))	++tbx;
		if(ty == 1)	isolate(nv,tbx,1);
		}
	else	{
		while(*is != ZERO && (*is <= ' ' || *is > '~'))		++is;
		if(ty == 1)	isolate(nv,is,1);
		}
	return(NULL);
}
char	*
fgetlk(os,us,fp)
FILE    *fp;
char    *os;
char	*us;
{
	REG	    char    *osx = os;
	REG	    char    *usx = us;
	REG	    int     cx;
	auto    int     bs = 0;
	*osx = ZERO;
	while(osx < usx && (cx = getc(fp)) != EOF)
	if(cx == CR)	continue;
	else
	if(cx == LF)   	{
		if(bs >= 1) *osx++ = cx;
		else        break;
		}
	else
	if(cx == ESC)
		switch(cx = getc(fp))	{
		case	CR:		break;
		case	LF:		ungetc(' ',fp);
						break;
		case	RCB:	*osx++ = ESC;
						*osx++ = RCB;
						bs -= 1;
						break;
		case	LCB:	*osx++ = ESC;
						*osx++ = LCB;
						bs += 1;
						break;
		default:		*osx++ = ESC;
						*osx++ = cx;
						break;
		}
	else    *osx++ = cx;
	*osx = ZERO;
	if(osx >= usx)  {
		errmsg("fgetlk <overflow>\n");
		terror(FUBAR);
		}
	if(bs)			{
		errmsg("fgetlk <bracket error> [%s]\n",os);
		terror(FUBAR);
		}
	if(osx > os)	return(osx);
	else			return(NULL);
}
char	*
xgnl(os,us,is)
char	*os;
char	*us;
char	*is;
{
	REG     char    *osx = os;
	REG     char    *isx = is;
	REG     char    *usx = us;
	auto	int		icb = 0;
	*osx = ZERO;
/**/
	while(*isx == LF)	++isx;
	if(isnull(isx))		return(NULL);
/**/
	while(osx < usx && *isx != ZERO)	{
	if(*isx == LF && icb <= 0)			break;
	else
	if(*isx == ESC && isx[1] == RCB)	{
		icb -= 1;
		*osx++ = *isx++;
		*osx++ = *isx++;
		if(icb <= 0)	break;
		}
	else
	if(*isx == ESC && isx[1] == LCB)	{
		icb += 1;
		*osx++ = *isx++;
		*osx++ = *isx++;
		}
	else	*osx++ = *isx++;
	}
	*osx = ZERO;
	if(osx >= usx)	{
		errmsg("xgnl <overflow>\n");
		terror(FUBAR);
		}
	if(icb)			{
		errmsg("xgnl <bracket error>\n");
		terror(FUBAR);
		}
	return(isx);
}
rdfile(nvc,fp,nl,ty)    /* read nl lines from a file */
int     nvc;        	/* position holder */
FILE    *fp;
int     nl;         	/* number of lines to read */
int		ty;				/* 1 = raw, 0 = divert */
{
	REG     int     nlx = 0;            /* line count */
	REG     int     nly = nl;
#ifdef	DEBUG
	fprintf(stderr,"rdfile(%u,%u,%u,%u)\n",nvc,fp,nl,ty);
#endif
	while(nlx < nly)	{
	if(nvc != nv)   {
		fp = x[nv].ifp;
		nvc = nv;
		}
	if(ty == 0)	{
		fgets(ls,BLKSIZ-1,fp);
		if(feof(fp))	break;
		divwrt(nv,ls);
		}
	else	{
		fgetlk(ls,ls+BLKSIZ-1,fp);
		if(feof(fp))	break;
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(0) rdfile: ");
	funxesc(ls,stderr);
	}
#endif
		isolate(nv,ls,ty);
		}
	nlx += 1;
	}
	return(nlx);
}
isolate(nvc,is,ty)      /* isolate input lines from processing */
int		nvc;			/* current environment */
char    *is;			/* string to process */
int		ty;				/* processing type */
{
	REG		char	*isx = is;
	auto	char	*ws = NULL;
	auto    char    *wsu = NULL;
/**/
	if(ty == 0)	dump("isolate:ty == 0");
/**/
#define	SAVE_IS
#ifdef	SAVE_IS
	isx = is = strsave(is);
#endif	SAVE_IS
	ws = emalloc(ISOSIZ,"isolate");
	wsu = ws + ISOSIZ - 1;
	il += 1;
/**/
/*
**	FONT specification is added to the beginning of every TEXT
**	line by xesc
*/
/**/
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(+0) isolate: ");
	funxesc(isx,stderr);
	}
#endif
	while((int)(isx = xgnl(ws,wsu,isx)))   {
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(+1) isolate: ");
	funxesc(ws,stderr);
	}
#endif
	if(ws[0] == x[nv].cc || ws[0] == x[nv].c2)  {
		if(ismac(ws+1)) {
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(69) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			mexpand(ws,wsu);
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(68) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			isolate(nv,ws,1);
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(67) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			continue;
			}
		else    {
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(0) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			mexpand(ws,wsu);
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(1) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			zesc(nv,ws,NOFONT);
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(2) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			xcmd(nv,ws);
			}
		}
	else    {
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(96) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			mexpand(ws,wsu);
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(97) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			zesc(nv,ws,ONFONT);
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"(98) isolate: ");
	funxesc(ws,stderr);
	}
#endif
			xtxt(nv,ws);
			}
	}
/**/
	il -= 1;
/**/
	ws = free_if(ws);
#ifdef	SAVE_IS
	isx = is = free_if(is);
#endif	SAVE_IS
	return(0);
}
