/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
/*EXTERN*/
/**/
char	*
fputlf(os,fp,fw)
char	*os;
FILE	*fp;
NOSIGN	fw;
{
	return(wrf(os,fp,fw,"\n"));
}
char	*
wrf(os,fp,fw,lt)		/* write line; fold */
NOSIGN		fw;		/* fold width */
char		*lt;		/* line terminator */
char		*os;		/* output string */
FILE		*fp;
{
	REG		char	*osx = os;
	auto	char	*ltx = NULL;
/**/
	if(fw == 0)	{
		fputs(os,fp);
		fputs("\n",fp);
		return(os);
	}
/**/
	if(isnull(lt))	ltx = "\n> ";
	else			ltx = lt;
/**/
	while((int) (osx = wrfl(osx,fp,fw,ltx)))	;
	return(os);
}
char	*
wrfl(os,fp,fw,lt)
NOSIGN		fw;		/* fold width */
char		*lt;		/* line terminator */
char		*os;		/* output string */
FILE		*fp;
{
	REG		char	*osx = os;
	REG		int	fwx = 0;
	REG		char	*eol = NULL;
/**/
	while(isspace(*osx))	++osx;
	if(isnull(osx))			return(NULL);
/**/
	while(fwx++ < fw && *osx != ZERO && !iseol(*osx))
	if(isspace(*osx))	eol = osx++;
	else				osx += 1;
/**/
	eol = (iseol(*osx) || isnull(osx)) ? osx : eol;
	eol = eol != NULL ? eol : osx;
	osx = os;
	while(osx < eol)	putc(*osx++,fp);
	if(iseol(*osx))		putc('\n',fp);
	else
	if(isnull(osx))		putc('\n',fp);
	else				fputs(lt,fp);
/**/
	while(isspace(*osx))	++osx;
	if(isnull(osx))			return(NULL);
	else					return(osx);
}
char	*
wrw(is,fp)	/* write line; trim spacing */
char	*is;
FILE	*fp;
{
	REG		char				*isx = is;
	while(isspace(*isx))		++isx;
	while(*isx != ZERO)
	if(isspace(*isx))	{
		while(isspace(*isx))	++isx;
		if(*isx == ZERO)		continue;
		else					putc(' ',fp);
		}
	else						putc(*isx++,fp);
	putc(LF,fp);
	return(is);
}

