#include	"pdtar.h"
#include	"pdproto.h"
/**/
/*EXTERN*/
/**/
create()
{
	static	char	*here = "create";
	device.wbc = 0;		/* important: makelist diddles */
	rewind(xfp);	/* rewind index list */
	archive();
	tar_eof();
	tar_write(T_CLOSE);
	return(0);
}
archive()
{
	static	char	*here = "archive";
	auto	char	ls[BUFSIZ];
	auto	char	*lx;
	auto	ino_t	inode;
	auto	long	fsize;
	auto	int		disk;
	auto	long	begin;
	auto	long	rsize;
	auto	int		ix;
/*
	this routine generates an archive from a set of instructions
	produced by makelist.
*/
	while(fgets(ls,BUFSIZ-1,xfp))	{
		strcnd(ls);
		switch(ls[0])	{
			case	'C':
				if(chdir(ls+2))	{
					where(here);
					perror(ls+2);
					terror(FUBAR);
					}
				break;
			case	'L':
				sscanf(ls+2,"%u %s %s",&inode,f_name,l_name);
				doalink(f_name,l_name);
				if(oswitch.unhinge)	unhinge(f_name);
				break;
			case	'F':
				sscanf(ls+2,
					"%u %s %ld %d\n",
						&inode,f_name,&fsize,&device.extotal);
				lx = strchr(ls,'!');
				for(ix = 0; ix < device.extotal; ix++)	{
					lx = strchr(lx,'E') + 1;
					sscanf(lx,
						"%d %d %ld %ld",
							&device.extno,&disk,&begin,&rsize);
					doaseg(f_name,begin,rsize);
					}
				if(oswitch.unhinge)	unhinge(f_name);
				break;
			default:
				where(here);
				fprintf(stderr,"<unknown> '%c'\n",ls[0]);
				fflush(stderr);
				abort();
				break;
			}
		}
	return(0);
}
doalink(f_name,l_name)
char	*f_name;
char	*l_name;
{
	static	char	*here = "doalink";
	auto	RECORD	*header = &curhead;
	auto	int		blocks = 1;
/**/
	phstat = &hstat;
/**/
	if(badstat(f_name,phstat,here))	abort();
/**/
	encode('L',f_name,l_name,phstat,header);
	chkhead(header);
	tar_place((char *) header,1,"head");
/**/
	if(oswitch.verbose)	tellblocks('L',f_name,l_name,blocks);
	return(blocks);
}
doaseg(f_name,begin,rsize)
char	*f_name;
long	begin;
long	rsize;
{
	static	char	*here = "doaseg";
	auto	int		blocks = 0;
	auto	RECORD	*header = &curhead;
/*
|	if this file is split, fudge the header for Xenix extent format.
*/
	phstat = &hstat;
	if(badstat(f_name,phstat,here))	abort();
#ifdef	MSDOS
/*
|	archiving here so we should be converting to standard time if
|	operating under MSDOS.
*/
	if(oswitch.convert)	{
		phstat->st_mtime = ktimedtu(phstat->st_mtime);
		}
#endif	/*MSDOS*/
	if(device.extotal >= 2)	{
		device.extno += 1;
		if(oswitch.verbose)	{
			if(device.extno == 1)	{
				fprintf(stdrpt,
					"\007<large file> %d extents (%s)\n",
						device.extotal,f_name);
				}
			else	{
				fprintf(stdrpt,
					"<extent> %d of %d (%s)\n",
						device.extno,device.extotal,f_name);
				}
			}
		device.efsize = phstat->st_size;
		phstat->st_size = rsize;
		}
	else	{
		device.efsize = device.extno = device.extotal = 0;
		}
/**/
	encode('F',f_name,NULL,phstat,header);
/**/
	chkhead(header);
/**/
	tar_place((char *) header,1,"head");
/**/
	blocks = rdwrfile(f_name,begin,rsize);
/**/
	if(oswitch.verbose)	tellblocks('F',f_name,NULL,blocks+1);
/**/
	return(blocks);
}
tellblocks(ty,f_name,l_name,blocks)
int		ty;
char	*f_name;
char	*l_name;
int		blocks;
{
	fprintf(stdrpt,"a %s",f_name);
	if(ty == 'L')
	fprintf(stdrpt," -> %s",l_name);
	fprintf(stdrpt," %d blocks ",blocks);
	if(device.bpf)
	fprintf(stdrpt," (%d)",device.wbc);
	fprintf(stdrpt,"\n");
	fflush(stdrpt);
	return(1);
}
void
estimate()		/* estimate disks needed */
{
	fprintf(stdrpt,"%4d total file(s)\n",nfiles);
	fprintf(stdrpt,"%4d split file(s)\n",nsplit);
	fprintf(stdrpt,"%4d linked file(s)\n",nlinks);
	fprintf(stdrpt,"%4d disk(s) needed\n",ndisk+1);
	return;
}
